
/** Projet 3ETI - CPE Lyon - 2011-2012 */


#ifndef _GENERATEUR_HPP_
#define _GENERATEUR_HPP_

#include <element_electronique.hpp>
#include <signal.hpp>

namespace cpe
{
    /** Class contenant un generateur de tension */
    class generateur : public element_electronique
    {
    public:

        // ******************************************************** //
        // Constructeur
        // ******************************************************** //

        /** \brief constructeur vide */
        generateur();

        // ******************************************************** //
        // Generation de signal
        // ******************************************************** //

        /** \brief cree un signal sinusoidale d'amplitude et de frequence donnée, echantillonné suivant dt pour N valeurs */
        void generate_sinus(double amplitude,double frequency, double dt,unsigned int N);
        /** \brief cree un signal constant d'amplitude donnée, echantillonné suivant dt pour N valeurs */
        void generate_constant(double amplitude,double dt,unsigned int N);
        /** \brief cree un signal rectangulaire d'amplitude et de frequence donnée, echantillonné suivant dt pour N valeurs */
        void generate_rectangle(double amplitude,double frequency,double dt,unsigned int N);

        // ******************************************************** //
        // Acces aux donnees
        // ******************************************************** //

        /** \brief renvoie le signal */
        const signal& get_signal() const;

    private:

        /** \brief signal stocké en interne */
        signal signal_internal;

    };
}

#endif
