
/** Projet 3ETI - CPE Lyon - 2011-2012 */

#include <mywidget.hpp>
#include <cmath>

#include <vector>

mywidget::mywidget(QWidget *obj)
    :QWidget(obj){}


void mywidget::paintEvent(QPaintEvent *e)
{

    //creation du QPainter pour dessiner a l'ecran
    QPainter painter(this);

    //largeur et hauteur courante
    double w=this->width();
    double h=this->height();




    //on genere un signal ici
    unsigned int N=500;
    std::vector<QPointF> mon_signal;
    for(unsigned int k=0;k<N;++k)
    {
        //x varie entre [0,1] quand k varie entre [0,N]
        double x=static_cast<double>(k)/static_cast<double>(N-1);
        //on genere un signal
        double y=sin(10*M_PI*x);

        //on transforme le signal pour que ses coordonnees s'affichent dans l'image
        double x_pixel=(x*w)*0.8+0.1*w;
        double y_pixel=(y*h/2.0)*0.8+0.5*h;

        //on sauve le signal
        mon_signal.push_back(QPointF(x_pixel,y_pixel));
    }

    //on va afficher en bleu
    painter.setPen(QPen(Qt::blue,2));

    //on affiche le signal ici
    for(unsigned int k=0;k<N-1;++k)
        painter.drawLine(mon_signal[k],mon_signal[k+1]);

    //on affiche du texte
    painter.setPen(QPen(Qt::black,2));
    painter.drawText(QPointF(0.45*w,0.075*h),QString("Signal de ")+QString::number(N)+QString(" points"));

    //on affiche la ligne centrale
    painter.drawLine(QPointF(0.1*w,0.5*h),QPointF(0.9*w,0.5*h));
    painter.drawLine(QPointF(0.1*w,0.1*h),QPointF(0.1*w,0.9*h));

    e->accept();

}
